/* 
* -cr_beg-
* ********************************************************************
* Licensed Materials - Property of IBM
* Restricted Materials of IBM
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
*  Copyright IBM Corp. 2013
* ********************************************************************
* -cr_end-
*/ 
#define SQL_TEXT Latin_Text
#include <sqltypes_td.h>

#include "ODPPTeraUDF.h"

void OptimMaskInt64Time(ANSI_Time *Field1,
                        VARCHAR_LATIN *ProviderStr,
                        BIGINT *result,
                        int *Field1NullInd,
                        int *ProviderStrNullInd,
                        int *resultNullInd,
                        char sqlstate[6],
                        SQL_TEXT functionName[],
                        SQL_TEXT specificName[],
                        SQL_TEXT errorMessage[256])
{
   ODPPTeraMaskSQLCA sqlca;
   ODPPTeraTime InTime;

   ODPPTeraMaskInitSQLCALatin(&sqlca, sqlstate, functionName, specificName, errorMessage);

   if (*ProviderStrNullInd)
   {
      *resultNullInd = -1;
      return;
   }

   if (! *Field1NullInd)
   {
      InTime.hour = Field1->hour;
      InTime.minute = Field1->minute;
      InTime.seconds = Field1->seconds;
   }

   ODPPTeraMaskInt64Time(ProviderStr, &InTime, *Field1NullInd, result, resultNullInd, &sqlca);
   return;
}
