/* 
* -cr_beg-
* ********************************************************************
* Licensed Materials - Property of IBM
* Restricted Materials of IBM
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
*  Copyright IBM Corp. 2013
* ********************************************************************
* -cr_end-
*/ 
#define SQL_TEXT Latin_Text
#include <sqltypes_td.h>

#include "ODPPTeraUDF.h"

void OptimMaskInt64Timestamp(TimeStamp *Field1,
                             VARCHAR_LATIN *ProviderStr,
                             BIGINT *result,
                             int *Field1NullInd,
                             int *ProviderStrNullInd,
                             int *resultNullInd,
                             char sqlstate[6],
                             SQL_TEXT functionName[],
                             SQL_TEXT specificName[],
                             SQL_TEXT errorMessage[256])
{
   ODPPTeraMaskSQLCA sqlca;
   ODPPTeraTimestamp InTimestamp;

   ODPPTeraMaskInitSQLCALatin(&sqlca, sqlstate, functionName, specificName, errorMessage);

   if (*ProviderStrNullInd)
   {
      *resultNullInd = -1;
      return;
   }

   if (! *Field1NullInd)
   {
      InTimestamp.year = Field1->year;
      InTimestamp.month = Field1->month;
      InTimestamp.day = Field1->day;
      InTimestamp.hour = Field1->hour;
      InTimestamp.minute = Field1->minute;
      InTimestamp.seconds = Field1->seconds;
   }

   ODPPTeraMaskInt64Timestamp(ProviderStr, &InTimestamp, *Field1NullInd, result, resultNullInd, &sqlca);
   return;
}
