/* 
* -cr_beg-
* ********************************************************************
* Licensed Materials - Property of IBM
* Restricted Materials of IBM
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
*  Copyright IBM Corp. 2013
* ********************************************************************
* -cr_end-
*/ 
#define SQL_TEXT Latin_Text
#include <sqltypes_td.h>

#include "ODPPTeraUDF.h"

void OptimMaskTimestampTimestamp(TimeStamp *Field1,
                                 VARCHAR_LATIN *ProviderStr,
                                 TimeStamp *result,
                                 int *Field1NullInd,
                                 int *ProviderStrNullInd,
                                 int *resultNullInd,
                                 char sqlstate[6],
                                 SQL_TEXT functionName[],
                                 SQL_TEXT specificName[],
                                 SQL_TEXT errorMessage[256])
{
   ODPPTeraMaskSQLCA sqlca;
   ODPPTeraTimestamp InTimestamp;
   ODPPTeraTimestamp OutTimestamp;

   ODPPTeraMaskInitSQLCALatin(&sqlca, sqlstate, functionName, specificName, errorMessage);

   if (*ProviderStrNullInd)
   {
      *resultNullInd = -1;
      return;
   }

   if (! *Field1NullInd)
   {
      InTimestamp.year = Field1->year;
      InTimestamp.month = Field1->month;
      InTimestamp.day = Field1->day;
      InTimestamp.hour = Field1->hour;
      InTimestamp.minute = Field1->minute;
      InTimestamp.seconds = Field1->seconds;
   }

   ODPPTeraMaskTimestamp(ProviderStr, &InTimestamp, *Field1NullInd, &OutTimestamp, resultNullInd, &sqlca);

   if (! *resultNullInd)
   {
      result->year = OutTimestamp.year;
      result->month = OutTimestamp.month;
      result->day = OutTimestamp.day;
      result->hour = OutTimestamp.hour;
      result->minute = OutTimestamp.minute;
      result->seconds = OutTimestamp.seconds;
   }

   return;
}
